/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import java.io.PrintWriter;
import org.osgi.framework.ServiceReference;

// the Java reference to the Runnable service
Runnable service;

// Command functions 
public String getName(){
	return "bench2";
}

public String getUsage(){
	return "bench2 <nbloop>";
}

public String getShortDescription(){
	return "bench a Runnable service";
}

public void execute(String commandLine, PrintWriter out, PrintWriter err){
	int nbcalls=100000;				
	long startTime=java.lang.System.currentTimeMillis();
	for(int n = 0; n <nbcalls; n++){
		service.run();
	}
	long endTime=java.lang.System.currentTimeMillis();
	long time=endTime-startTime;
	out.println(time+" millisec. for "+nbcalls+" calls ("+(time*1000.0)/nbcalls+" microsec. per call)");
}

// Binding/unbinding functions 
public void bindRunnable(ServiceReference svcref, Runnable svc){
	service=svc;
}

public void unbindRunnable(ServiceReference svcref, Runnable svc){
	service=null;
}				
				
/*
// Lifecycle functions
function activate(){
	// do something
	java.lang.System.out.println("sosoc.bench.command: call activate() function");
}

function deactivate(){
	java.lang.System.out.println("sosoc.bench.command: call deactivate() function");
	// do something
}
*/				
