/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
//-- Component script source used by SOSOC --
//-- July 17 2005  --
/**
 * @author <a href="mailto:dev@felix.apache.org">Felix Project Team</a>
 */
		
				// the Java reference to the LogService
				var service;
				
				// Command functions 
				function getName(){
					return "echo";
				}

				function getUsage(){
					return "echo <msg>";
				}

				function getShortDescription(){
					return "echo and log a line";
				}

				function execute(commandLine,out,err){
					if(service!=undefined){
						out.println("Log the message");
						service.log(3,commandLine); // INFO log level
					}
					out.println(commandLine);
				}
		
				// Binding/unbinding functions 
				function bindLogService(svcref,svc){
					service=svc;
				}

				function unbindLogService(svcref,svc){
					service=undefined; // undefined is null in JavaScript
				}
				
				// Lifecycle functions
				function activate(){
					// do something
					java.lang.System.out.println("echocmd.js: call activate() function");
				}
				
				function deactivate(){
					java.lang.System.out.println("echocmd.js: call deactivate() function");
					// do something
				}
				
