//-- Component script source used by SOSOC --
//-- July 17 2005  --
/*
 * Script Evaluator UI - enables to evaluate JavaScript expressions in the component scope
 */


var frame;

var swingNames = JavaImporter();

swingNames.importPackage(Packages.javax.swing);
swingNames.importPackage(Packages.javax.swing.text);
swingNames.importPackage(Packages.java.awt);
swingNames.importPackage(Packages.java.awt.event);
swingNames.importPackage(Packages.org.mozilla.javascript);

function createComponents() 
{
    with (swingNames) {
        var text = new JEditorPane();
        var button = new JButton("Eval script");
        button.mnemonic = KeyEvent.VK_I;
        // Since Rhino 1.5R5 JS functions can be passed to Java method if
        // corresponding argument type is Java interface with single method
        // or all its methods have the same number of arguments and the
        // corresponding arguments has the same type. See also comments for
        // frame.addWindowListener bellow
        button.addActionListener(function() {
            //java.lang.System.out.println(eval(text.getText()));
            java.lang.System.out.println(context.evaluateString(this, text.getText(), null, 0, null));
        });

        /*
         * An easy way to put space between a top-level container
         * and its contents is to put the contents in a JPanel
         * that has an "empty" border.
         */
        var pane = new JPanel();
        pane.border = BorderFactory.createEmptyBorder(10, //top
                                                      10, //left
                                                      10, //bottom
                                                      10); //right
        
        
        //pane.setLayout(new GridLayout(0, 1));
        pane.setLayout(new BorderLayout());
        pane.add(text, BorderLayout.CENTER);
        pane.add(button, BorderLayout.SOUTH);

        return pane;
    }
}

function startUI(){
with (swingNames) {
    try {
		UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    } catch (e) { }

    //Create the top-level container and add contents to it.
    frame = new JFrame("Script Evaluator");
    frame.getContentPane().add(createComponents(), BorderLayout.CENTER);

    // Pass JS function as implementation of WindowListener. It is allowed since 
    // all methods in WindowListener have the same signature. To distinguish 
    // between methods Rhino passes to JS function the name of corresponding 
    // method as the last argument  
    frame.addWindowListener(function(event, methodName) {
	if (methodName == "windowClosing") {     
            //java.lang.System.exit(0);
            //java.lang.System.out.println("existing Swing application on close");
            stopUI();
	}
    });

    //Finish setting up the frame, and show it.
    //frame.pack();
    frame.setSize(400,200);
    frame.setVisible(true);
}
}
function stopUI(){
  with (swingNames) {
	frame.dispose();
    java.lang.System.out.println("existing Swing application");
  }	
}
// Lifecycle functions

var context;

function activate(){
	context = Packages.org.mozilla.javascript.Context.enter();
	startUI();
}
				
function deactivate(){
	stopUI();
	context.exit();
}
