#
#  Licensed to the Apache Software Foundation (ASF) under one
#  or more contributor license agreements.  See the NOTICE file
#  distributed with this work for additional information
#  regarding copyright ownership.  The ASF licenses this file
#  to you under the Apache License, Version 2.0 (the
#  "License"); you may not use this file except in compliance
#  with the License.  You may obtain a copy of the License at
# 
#    http://www.apache.org/licenses/LICENSE-2.0
# 
#  Unless required by applicable law or agreed to in writing,
#  software distributed under the License is distributed on an
#  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
#  KIND, either express or implied.  See the License for the
#  specific language governing permissions and limitations
#  under the License.
#
package require java
source grid.tcl

set but [java::new java.awt.Button Say]

proc setLab {} {
    $lab setText $tf getText
}

set f [java::new java.awt.Frame]
set tf [java::new java.awt.TextField "SOSOC"]
set lab [java::new java.awt.Label "Hello"]

set layout [java::new java.awt.FlowLayout]
$f setLayout $layout

$f {add java.awt.Component} $lab
$f {add java.awt.Component} $tf
$f {add java.awt.Component} $but

$f setLocation 100 100
$f pack
$f show
$f toFront
$f setTitle "SOSOC TCL Example"

#
# Event bindings
#

java::bind $but actionPerformed "setLab"

java::bind $f windowClosing "set done yes"

#
# Loop forever to handle GUI events
#

vwait done

#
# We're done with the window. Dispose it.
#

$f dispose

