//-- Component script source used by SOSOC --
//-- July 17 2005  --
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
				function Component(){
					this.service=undefined;
					this.end=false;
					this.stop=function() { this.end=true; };
					this.run=function() {
						var i=0;
						while(!this.end){
							java.lang.System.out.println(this.service.log(3,"Hello from thread.js !"+(i++)));
							java.lang.Thread.sleep(2000);
						}
					};
					this.setService=function(svc) { this.service=svc; };
					return this;		
				}

				var comp=new Component();

/*
				// JSON notation
				var comp = {
					service: undefined;
					end: false;
					stop: function() { end=true; }
					run: function() { while(!end){java.lang.System.out.println(service.log(3,"Hello from thread.js !"));} };
					setService: function(svc) { service=svc; }		
				}
*/
										
				// Binding/unbinding functions 
				function bindLogService(svcref,svc){
					comp.setService(svc);
				}

				function unbindLogService(svcref,svc){
					comp.setService(undefined); // undefined is null in JavaScript
				}
				
				// Lifecycle functions
				function activate(){
					r = new java.lang.Runnable(comp);
					t = new java.lang.Thread(r);
					t.start();
				}
				
				function deactivate(){
					comp.stop();
				}
